SystemOrganization addCategory: #TOcurricula!

Object subclass: #Consultor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOcurricula'!

!Consultor methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 11/9/2012 11:44'!
cargarDataFile: arc
	"En esta funcion vamos a abrir el file que contiene la informacion que se graficara
	y se devolver la matriz o array que contiene la informacion de los cursos"
	| arch col stream1 stream2 mat data cad |
	arch := FileStream fileNamed: arc.
	mat := OrderedCollection new.
	data := OrderedCollection new.
	stream1 := (arch contentsOfEntireFile) readStream .
	stream2 := (arch contentsOfEntireFile) readStream .
	[stream1 atEnd not & stream2 atEnd not] whileTrue: [
		stream1 skipTo: $%.	"encuentra el simbolo de separacion"
		cad := stream2 next: ((stream1 position - stream2 position )- 1).
		mat add: cad asString. 
		stream2 next. 	"avanza una posicion despues del simbolo de separacion para leer la nueva palabra"
		(stream2 peek = $#) ifTrue: [ stream2 next. data add: mat. mat := OrderedCollection new. ]
	].
	data removeFirst.
	^data.! !

!Consultor methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 11/9/2012 11:35'!
cargarDataUrl: nomLink
	| data jsonObject subs tam |
	jsonObject := self conectarTo: nomLink.
	data := OrderedCollection new.
	subs :=	jsonObject at: 'feed'.
	subs := subs at: 'entry'.
	tam := subs size .
	1 to: tam do: [:pos | 
		| mat | 
		mat := OrderedCollection new.
		mat add: (((subs at: pos) at: 'gsx$codigo') at: '$t').
		mat add: (((subs at: pos) at: 'gsx$nombre') at: '$t').
		mat add: (((subs at: pos) at: 'gsx$cred') at: '$t').
		mat add: (((subs at: pos) at: 'gsx$prereq1') at: '$t').
		mat add: (((subs at: pos) at: 'gsx$prereq2') at: '$t').
		mat add: (((subs at: pos) at: 'gsx$prereq3') at: '$t').
		mat add: (((subs at: pos) at: 'gsx$prereq4') at: '$t').
		mat add: (((subs at: pos) at: 'gsx$hrsteoria') at: '$t').
		mat add: (((subs at: pos) at: 'gsx$hrsprac') at: '$t').
		mat add: (((subs at: pos) at: 'gsx$hrsteoprac') at: '$t').
		mat add: (((subs at: pos) at: 'gsx$hrstotal') at: '$t').		
		data add: mat.
	].
	^data! !

!Consultor methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 11/9/2012 10:11'!
conectarTo: cad
	| dir parser jsonObject json subs root|
	(cad ~= '') ifTrue: [dir := cad] 
		ifFalse: [dir := 'http://spreadsheets.google.com/feeds/list/0AjE_p7Re6WDHdEJKUEVIM0dLWlY1TjRPZnQ1ZnVyVGc/od6/public/values?alt=json'].		
	parser := PPParserResource current parserAt: PPJsonParser.
	json := (Url absoluteFromText: dir) retrieveContents contents.
	jsonObject := parser parse: json.
	^jsonObject 
! !

Object subclass: #Visualizador
	instanceVariableNames: 'cursos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOcurricula'!

!Visualizador methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 11/9/2012 14:08'!
buscar: codigo en: matriz
	| i enc|
	i := 0.
	enc := 0.
	[enc = 0] whileTrue: [
		i := i + 1.
		((matriz at: i) first = codigo ) ifTrue: [enc := 1]
	].
	(i <= (matriz size)) ifTrue: [^i]! !

!Visualizador methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 11/9/2012 14:10'!
mostrarFrom: nomSource
	|view cod tam |
	cursos := Consultor new cargarDataUrl: nomSource.		"Cargamos la matriz de los cursos que tenemos almacenados"
	view := MOViewRenderer new.
	tam := cursos size.
	1 to: tam do: [:i | 
		| cls | 
		cls := cursos at: i.
		"Establecemos una accion de informacion cuando se haga clic en el nodo"
		view interaction on: MOMouseDouble do: [ :ann | 
			self mostrarInfo: (ann model)
		].
	
		cod := cls first .
		"view interaction forward.
		view shape arrowedLine."
		view shape label.
		view shape rectangle width: 50; withText; fontSize: 10.
		view node: cod.		
		view shape: (MOArrowedOrthoVerticalLineShape new).
		
		"Aqui analizamos los prerequisitos de cada uno de los cursos, para mostrar la relacion entre ambos"
		4 to: 7 do: [:j |
			cod := cls at: j.
			(cod = '' | cod = ' ') ifFalse: [
				view edges: { cod -> (cls first) } from: #key to: #value ]
		].
	].	
	view treeLayout. 
	view open ! !

!Visualizador methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 11/9/2012 14:19'!
mostrarInfo: codigo
	| pos matAux |
	pos := self buscar: codigo en: cursos .
	matAux := cursos at: pos.
	self inform: 'Codigo: ', (matAux at: 1), String cr,
				'Nombre: ', (matAux at: 2), String cr,
				'Creditos: ', (matAux at: 3), String cr,
				'Hrs Teoria: ', (matAux at: 8), String cr,
				'Hrs Practica: ', (matAux at: 9), String cr,
				'Hrs TeoricoPracticas: ', (matAux at: 10), String cr,
				'Horas totales: ', (matAux last).! !
